/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the CreateCveRecordResponseCreated type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CreateCveRecordResponseCreated{}

// CreateCveRecordResponseCreated struct for CreateCveRecordResponseCreated
type CreateCveRecordResponseCreated struct {
	Containers *CreateCveRecordResponseCreatedContainers `json:"containers,omitempty"`
	CveMetadata *GetCveRecordResponseCveMetadata `json:"cveMetadata,omitempty"`
	DataType *string `json:"dataType,omitempty"`
	DataVersion *string `json:"dataVersion,omitempty"`
}

// NewCreateCveRecordResponseCreated instantiates a new CreateCveRecordResponseCreated object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCreateCveRecordResponseCreated() *CreateCveRecordResponseCreated {
	this := CreateCveRecordResponseCreated{}
	return &this
}

// NewCreateCveRecordResponseCreatedWithDefaults instantiates a new CreateCveRecordResponseCreated object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCreateCveRecordResponseCreatedWithDefaults() *CreateCveRecordResponseCreated {
	this := CreateCveRecordResponseCreated{}
	return &this
}

// GetContainers returns the Containers field value if set, zero value otherwise.
func (o *CreateCveRecordResponseCreated) GetContainers() CreateCveRecordResponseCreatedContainers {
	if o == nil || IsNil(o.Containers) {
		var ret CreateCveRecordResponseCreatedContainers
		return ret
	}
	return *o.Containers
}

// GetContainersOk returns a tuple with the Containers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordResponseCreated) GetContainersOk() (*CreateCveRecordResponseCreatedContainers, bool) {
	if o == nil || IsNil(o.Containers) {
		return nil, false
	}
	return o.Containers, true
}

// HasContainers returns a boolean if a field has been set.
func (o *CreateCveRecordResponseCreated) HasContainers() bool {
	if o != nil && !IsNil(o.Containers) {
		return true
	}

	return false
}

// SetContainers gets a reference to the given CreateCveRecordResponseCreatedContainers and assigns it to the Containers field.
func (o *CreateCveRecordResponseCreated) SetContainers(v CreateCveRecordResponseCreatedContainers) {
	o.Containers = &v
}

// GetCveMetadata returns the CveMetadata field value if set, zero value otherwise.
func (o *CreateCveRecordResponseCreated) GetCveMetadata() GetCveRecordResponseCveMetadata {
	if o == nil || IsNil(o.CveMetadata) {
		var ret GetCveRecordResponseCveMetadata
		return ret
	}
	return *o.CveMetadata
}

// GetCveMetadataOk returns a tuple with the CveMetadata field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordResponseCreated) GetCveMetadataOk() (*GetCveRecordResponseCveMetadata, bool) {
	if o == nil || IsNil(o.CveMetadata) {
		return nil, false
	}
	return o.CveMetadata, true
}

// HasCveMetadata returns a boolean if a field has been set.
func (o *CreateCveRecordResponseCreated) HasCveMetadata() bool {
	if o != nil && !IsNil(o.CveMetadata) {
		return true
	}

	return false
}

// SetCveMetadata gets a reference to the given GetCveRecordResponseCveMetadata and assigns it to the CveMetadata field.
func (o *CreateCveRecordResponseCreated) SetCveMetadata(v GetCveRecordResponseCveMetadata) {
	o.CveMetadata = &v
}

// GetDataType returns the DataType field value if set, zero value otherwise.
func (o *CreateCveRecordResponseCreated) GetDataType() string {
	if o == nil || IsNil(o.DataType) {
		var ret string
		return ret
	}
	return *o.DataType
}

// GetDataTypeOk returns a tuple with the DataType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordResponseCreated) GetDataTypeOk() (*string, bool) {
	if o == nil || IsNil(o.DataType) {
		return nil, false
	}
	return o.DataType, true
}

// HasDataType returns a boolean if a field has been set.
func (o *CreateCveRecordResponseCreated) HasDataType() bool {
	if o != nil && !IsNil(o.DataType) {
		return true
	}

	return false
}

// SetDataType gets a reference to the given string and assigns it to the DataType field.
func (o *CreateCveRecordResponseCreated) SetDataType(v string) {
	o.DataType = &v
}

// GetDataVersion returns the DataVersion field value if set, zero value otherwise.
func (o *CreateCveRecordResponseCreated) GetDataVersion() string {
	if o == nil || IsNil(o.DataVersion) {
		var ret string
		return ret
	}
	return *o.DataVersion
}

// GetDataVersionOk returns a tuple with the DataVersion field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CreateCveRecordResponseCreated) GetDataVersionOk() (*string, bool) {
	if o == nil || IsNil(o.DataVersion) {
		return nil, false
	}
	return o.DataVersion, true
}

// HasDataVersion returns a boolean if a field has been set.
func (o *CreateCveRecordResponseCreated) HasDataVersion() bool {
	if o != nil && !IsNil(o.DataVersion) {
		return true
	}

	return false
}

// SetDataVersion gets a reference to the given string and assigns it to the DataVersion field.
func (o *CreateCveRecordResponseCreated) SetDataVersion(v string) {
	o.DataVersion = &v
}

func (o CreateCveRecordResponseCreated) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CreateCveRecordResponseCreated) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Containers) {
		toSerialize["containers"] = o.Containers
	}
	if !IsNil(o.CveMetadata) {
		toSerialize["cveMetadata"] = o.CveMetadata
	}
	if !IsNil(o.DataType) {
		toSerialize["dataType"] = o.DataType
	}
	if !IsNil(o.DataVersion) {
		toSerialize["dataVersion"] = o.DataVersion
	}
	return toSerialize, nil
}

type NullableCreateCveRecordResponseCreated struct {
	value *CreateCveRecordResponseCreated
	isSet bool
}

func (v NullableCreateCveRecordResponseCreated) Get() *CreateCveRecordResponseCreated {
	return v.value
}

func (v *NullableCreateCveRecordResponseCreated) Set(val *CreateCveRecordResponseCreated) {
	v.value = val
	v.isSet = true
}

func (v NullableCreateCveRecordResponseCreated) IsSet() bool {
	return v.isSet
}

func (v *NullableCreateCveRecordResponseCreated) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCreateCveRecordResponseCreated(val *CreateCveRecordResponseCreated) *NullableCreateCveRecordResponseCreated {
	return &NullableCreateCveRecordResponseCreated{value: val, isSet: true}
}

func (v NullableCreateCveRecordResponseCreated) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCreateCveRecordResponseCreated) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


